; ##############################################################################
; ##############################################################################
; ##############################################################################
FW_EINTRAG:
.equ FWmax=1000
	LDS ZL,(adr_FW_ANGRIFFE_L)	; COUNTER	
	LDS ZH,(adr_FW_ANGRIFFE_H)
	adiw ZL,1
	STS(adr_FW_ANGRIFFE_L),ZL
	STS(adr_FW_ANGRIFFE_H),ZH
;-------------------------------------------------------------------------------
	call FW_IP_SEARCH_C
	brcc FW_EINTRAG_NEU
;-------------------------------------------------------------------------------
FW_EINTRAG_VORHANDEN:
	ret
;-------------------------------------------------------------------------------
FW_EINTRAG_NEU:
	LDS ZL,(adr_FW_ANGRIFFE_NEU_L)	; COUNTER	
	LDS ZH,(adr_FW_ANGRIFFE_NEU_H)
	adiw ZL,1
	STS(adr_FW_ANGRIFFE_NEU_L),ZL
	STS(adr_FW_ANGRIFFE_NEU_H),ZH

	ldi ZL, low(adr_FW_DATA)	; Z	
	ldi ZH,high(adr_FW_DATA)
	LDS XL,(adr_FW_POINTER_L)	; X	
	LDS XH,(adr_FW_POINTER_H)
	LSL XL						; x2
	ROL XH
	LSL XL						; x2
	ROL XH
	add ZL,XL					; addieren	
	adc ZH,XH
	LDS temp1,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)
	LDS temp2,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)
	LDS temp3,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)
	LDS temp4,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)
	ST Z+,temp1				; (adr_FW_IP0)
	ST Z+,temp2				; (adr_FW_IP1)
	ST Z+,temp3				; (adr_FW_IP2)
	ST Z+,temp4				; (adr_FW_IP3)
;-------------------------------------------------------------------------------
	LDS XL,(adr_FW_POINTER_L)	; Pointer +1	
	LDS XH,(adr_FW_POINTER_H)
	adiw XL,1
	cpi XH,high(FWmax)
	brlo FW_EINTRAG_w
	breq FW_EINTRAG_L
	brsh FW_EINTRAG_c
FW_EINTRAG_L:
	cpi XL, low(FWmax)
	brlo FW_EINTRAG_w
FW_EINTRAG_c:
	clr XL
	clr XH
FW_EINTRAG_w:
	STS(adr_FW_POINTER_L),XL
	STS(adr_FW_POINTER_H),XH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FW_CLEAR:
	ldi ZL, low(adr_FW_DATA)
	ldi ZH,high(adr_FW_DATA)
	ldi XL, low(FWmax-1)	; Anzahl	
	ldi XH,high(FWmax-1)
FW_CLEAR_s:
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	ST Z+,NULL
	sbiw XL,1			; -1		
	tst XL
	brne FW_CLEAR_s
	tst XH
	brne FW_CLEAR_s
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: DatensatzNr(X) + C														
FW_IP_SEARCH_C:
	ldi ZL, low(adr_FW_DATA)
	ldi ZH,high(adr_FW_DATA)
	ldi XL, low(FWmax)		; Anzahl	
	ldi XH,high(FWmax)
;-------------------------------------------------------------------------------
FW_IP_SEARCH_s:
	LD temp1,Z+		;(adr_FW_IP0)
	LD temp2,Z+		;(adr_FW_IP1)
	LD temp3,Z+		;(adr_FW_IP2)
	LD temp4,Z+		;(adr_FW_IP3)
	LDS temp5,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)
	LDS temp6,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)
	LDS temp7,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)
	LDS temp8,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)
	sbiw XL,1		; -1			
	tst XL
	brne FW_IP_SEARCH_w 
	tst XH
	brne FW_IP_SEARCH_w
	CLC 			; not found Clear Carry	
	ret
;-------------------------------------------------------------------------------
FW_IP_SEARCH_w:
	cp temp1,temp5
	brne FW_IP_SEARCH_s
	cp temp2,temp6
	brne FW_IP_SEARCH_s
	cp temp3,temp7
	brne FW_IP_SEARCH_s
	cp temp4,temp8
	brne FW_IP_SEARCH_s
	SEC 				;found Set Carry
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

