; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp,(adr_TASTE)		; eine Taste bettigt ?	
	tst temp
	breq MENUE_RUN
;-------------------------------------------------------------------------------
	LED_ONLINE_OFF
	LED_ROT_OFF
	call LCD_CLEAR
	call TASTE_MENUE_PLUS_C	; TASTE '+'				
	brcc MENUE_NO_PLUS
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_NO_PLUS:
	call TASTE_MENUE_MINUS_C	; TASTE '-'					
	brcc MENUE_RUN
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	call ZEILE1
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp						; mal 2 wegen jmp	
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	ijmp							; Sprung nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp ANZEIGE_BEGRUESSUNG
	jmp MENUE_HAUPTMENUE
	jmp MENUE_IP_OFFENTLICH
	jmp MENUE_DNS_SERVER_EXTERN_AUSLESEN
	jmp MENUE_DNS_ZEITSERVER_AUSLESEN
	jmp MENUE_ZEIT_SERVER_AUSLESEN
	jmp ANZEIGE_HILFE_LED1
	jmp ANZEIGE_HILFE_LED2
	jmp ANZEIGE_STATUS_ANGRIFFE
	jmp ANZEIGE_STATUS_FIREWALL
	jmp ANZEIGE_STATUS_WEBSERVER
	jmp ANZEIGE_STATUS_ROUTER
	jmp ANZEIGE_STATUS_ENC
	jmp ANZEIGE_STATUS_MAC_HEADER
	jmp ANZEIGE_STATUS_IPv4
	jmp ANZEIGE_STATUS_ARP
	jmp ANZEIGE_STATUS_TCP_RX
	jmp ANZEIGE_STATUS_HTML
	jmp ANZEIGE_STATUS_1WIRE
	jmp ANZEIGE_STATUS_SYSTEM
	jmp ANZEIGE_ERROR
	jmp MENUE_ERROR_CLEAR
	jmp ANZEIGE_STATUS_USART_RS232
	jmp MENUE_WARNUNG
	jmp MENUE_ON_OFF_BEEP_ANGRIFFE
	jmp MENUE_ON_OFF_ARP_SCAN
	jmp MENUE_ON_OFF_DEBUG_RX
	jmp MENUE_ON_OFF_DEBUG_RX_UDP
	jmp MENUE_ON_OFF_DEBUG_TX
	jmp MENUE_ON_OFF_DEBUG_ANGRIFFE
	jmp MENUE_ON_OFF_FIREWALL
	jmp MENUE_FIREWALL_CLEAR
	jmp MENUE_WARNUNG
	jmp MENUE_EDIT_PORT_WEB_A
	jmp MENUE_EDIT_PORT_WEB_B
	jmp MENUE_EDIT_PORT_WEB_C
	jmp MENUE_EDIT_IP_ROUTER
	jmp MENUE_EDIT_IP_EIGENE
	jmp MENUE_EDIT_MAC_EIGENE
	jmp MENUE_TX_ENC_REGISTER
	jmp MENUE_SAVE
	jmp MENUE_WERKSEINSTELLUNG
	jmp ANZEIGE_BEGRUESSUNG
	jmp ANZEIGE_BEGRUESSUNG
	; berlauf						
	STS(adr_MENUE),NULL
	STS(adr_ERROR_MODUL_NR),NULL
	STS(adr_ERROR_CODE),NULL
	jmp EEPROM_SAVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HAUPTMENUE:
	call ANZEIGE_ZEIT_KURZ
	call ASCII_SPACE
	call ANZEIGE_AUSSENTEMPERATUR_KURZ

	call ZEILE2

	call ZEILE3


	call ZEILE4
	LDS temp1,(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr0)
	LDS temp2,(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr1)
	LDS temp3,(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr2)
	LDS temp4,(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr3)
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_IP_OFFENTLICH:
	call TEXT_IP
	call TEXT_SERVER
	call ASCII_e_
	call ASCII_x_
	call ASCII_t_
;-------------------------------------------------------------------------------
	call ZEILE2
	call FUNCTION_IP_SERVER_EXTERN_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
;-------------------------------------------------------------------------------
	call ZEILE3
	call TEXT_IP
	call TEXT_OFFENTLICH
;-------------------------------------------------------------------------------
	call ZEILE4
	call FUNCTION_IP_OFFENTLICH_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4

	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_IP_OFFENTLICH_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IP_OFFENTLICH_RUN:
	call FUNCTION_IP_SERVER_EXTERN_NULL
	call FUNCTION_IP_OFFENTLICH_NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DNS_SERVER_EXTERN_AUSLESEN:
	call TEXT_DNS
	call TEXT_SERVER
	call ASCII_e_
	call ASCII_x_
	call ASCII_t_
;-------------------------------------------------------------------------------
	call ZEILE4
	call FUNCTION_IP_SERVER_EXTERN_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
;-------------------------------------------------------------------------------
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_DNS_SERVER_EXTERN_AUSLESEN_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_DNS_SERVER_EXTERN_AUSLESEN_RUN:
	call FUNCTION_IP_SERVER_EXTERN_NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DNS_ZEITSERVER_AUSLESEN:
	call TEXT_DNS
	call TEXT_ZEITSERVER
;-------------------------------------------------------------------------------
	call ZEILE4
	call FUNCTION_IP_SERVER_EXTERN_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
;-------------------------------------------------------------------------------
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_UDP_DNS_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_UDP_DNS_RUN:
	call UTP_DNS_ZEITSERVER
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ZEIT_SERVER_AUSLESEN:
	call TEXT_ZEIT
	call TEXT_SERVER
	call TEXT_READ
;-------------------------------------------------------------------------------
	call ZEILE4
	call FUNCTION_IP_SERVER_EXTERN_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
;-------------------------------------------------------------------------------
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_TCP_ZEIT_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TCP_ZEIT_RUN:
	jmp TCP_ZEIT_AUSLESEN

; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ERROR_CLEAR:
	call TEXT_ERROR
	call TEXT_CLEAR
	call TASTE_PLUS_C
	brcs MENUE_ERROR_CLEAR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_ERROR_CLEAR_RUN:
	STS(adr_ERROR_MODUL_NR),NULL
	STS(adr_ERROR_CODE),NULL
	STS(adr_WARNUNG_CODE),NULL
;	STS(adr_ANZAHL_START_L),NULL
;	STS(adr_ANZAHL_START_H),NULL
	jmp EEPROM_SAVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARNUNG:
	call MENUE_WARNUNG_Z
	call ZEILE2
	call TEXT_WARNUNG
	call ZEILE3
	call MENUE_WARNUNG_Z
	call ZEILE4
	jmp  MENUE_WARNUNG_Z
;-------------------------------------------------------------------------------
MENUE_WARNUNG_Z:
	ldi temp9,16
MENUE_WARNUNG_s:
	call ASCII_VOLL
	dec temp9
	brne MENUE_WARNUNG_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_BEEP_ANGRIFFE:
	call TEXT_BEEP
	call TEXT_ANGRIFFE
	call ZEILE2
	LDS  temp1,(adr_FIREWALL_BEEP_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_FIREWALL_BEEP_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1				; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_ARP_SCAN:
	call TEXT_ARP
	call TEXT_SCAN
	call ZEILE2
	LDS temp1,(adr_ARP_SCAN_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_ARP_SCAN_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_DEBUG_RX:
	call TEXT_DEBUGG
	call TEXT_RX
	call ZEILE2
	LDS temp1,(adr_DEBUG_RX_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_DEBUG_RX_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_DEBUG_RX_UDP:
	call TEXT_DEBUGG
	call TEXT_RX
	call TEXT_UDP
	call ZEILE2
	LDS temp1,(adr_DEBUG_RX_UDP_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_DEBUG_RX_UDP_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_DEBUG_TX:
	call TEXT_DEBUGG
	call TEXT_TX
	call ZEILE2
	LDS temp1,(adr_DEBUG_TX_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_DEBUG_TX_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_FIREWALL:
	call TEXT_FIREWALL
	call ZEILE2
	LDS temp1,(adr_FIREWALL_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_FIREWALL_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ON_OFF_DEBUG_ANGRIFFE:
	call TEXT_DEBUGG
	call TEXT_ANGRIFFE
	call ZEILE2
	LDS temp1,(adr_DEBUG_ANGRIFFE_ON)
	call TASTE_PLUS_MINUS_TEMP1
	andi temp1,0b00000001
	STS(adr_DEBUG_ANGRIFFE_ON),temp1
	jmp ANZEIGE_ON_OFF_TEMP1			; ON/off
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_IP_EIGENE:
	call TEXT_EDIT
	call TEXT_IP
	call TEXT_EIGENE
	call ZEILE2
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
	call TASTE_PLUS_C
	brcs MENUE_EDIT_IP_EIGENE_RUN
	ret
;---------------------------------------------------------------------------
MENUE_EDIT_IP_EIGENE_RUN:
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	call EDIT_IP_TEMP1_2_3_4
	STS(adr_IP_EIGENE0),temp1
	STS(adr_IP_EIGENE1),temp2
	STS(adr_IP_EIGENE2),temp3
	STS(adr_IP_EIGENE3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_IP_ROUTER:
	call TEXT_EDIT
	call TEXT_IP
	call TEXT_ROUTER
	call ZEILE2
	call FUNCTION_IP_ROUTER_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
	call TASTE_PLUS_C
	brcs MENUE_EDIT_IP_ROUTER_RUN
	ret
;---------------------------------------------------------------------------
MENUE_EDIT_IP_ROUTER_RUN:
	call FUNCTION_IP_ROUTER_NACH_TEMP1_4
	call EDIT_IP_TEMP1_2_3_4
	STS(adr_IP_ROUTER0),temp1
	STS(adr_IP_ROUTER1),temp2
	STS(adr_IP_ROUTER2),temp3
	STS(adr_IP_ROUTER3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_MAC_EIGENE:
	call TEXT_EDIT
	call TEXT_MAC
	call TEXT_EIGENE
	call ZEILE2
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	call TASTE_PLUS_C
	brcs MENUE_EDIT_MAC_EIGENE_RUN
	ret
;---------------------------------------------------------------------------
MENUE_EDIT_MAC_EIGENE_RUN:
	call BEEP_LANG
MENUE_EDIT_MAC_EIGENE_s:
	call TASTEN_ABFRAGE
	LDS temp1,(adr_MAC5)
	call TASTE_PLUS_MINUS_TEMP1			; Taste "+/-"	
	STS(adr_MAC5),temp1
	call TASTE_MENUE_PLUS_C				; Menue "+"		
	brcs MENUE_EDIT_MAC_EIGENE_EXIT
	call ZEILE3
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	call ZEILE4
	call ASCII_SPACE10
	call ASCII_VOLL2
	call TASTEN_WAIT
	rjmp MENUE_EDIT_MAC_EIGENE_s
;---------------------------------------------------------------------------
MENUE_EDIT_MAC_EIGENE_EXIT:
	call BEEP_LANG
	call EEPROM_SAVE
	jmp PROGRAMM_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_PORT_WEB_A:
	call TASTE_PLUS_C
	brcs MENUE_EDIT_PORT_WEB_A_PLUS
	call TASTE_MINUS_C
	brcs MENUE_EDIT_PORT_WEB_A_MINUS
	jmp MENUE_EDIT_PORT_WEB_A_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_A_PLUS:
	LDS ZL,(adr_TCP_PORT_WEB_A_L)
	LDS ZH,(adr_TCP_PORT_WEB_A_H)
	adiw ZL,1
	STS(adr_TCP_PORT_WEB_A_L),ZL
	STS(adr_TCP_PORT_WEB_A_H),ZH
	jmp MENUE_EDIT_PORT_WEB_A_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_A_MINUS:
	LDS ZL,(adr_TCP_PORT_WEB_A_L)
	LDS ZH,(adr_TCP_PORT_WEB_A_H)
	sbiw ZL,1
	STS(adr_TCP_PORT_WEB_A_L),ZL
	STS(adr_TCP_PORT_WEB_A_H),ZH
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_A_w:
	call TEXT_EDIT
	call TEXT_PORT
	call TEXT_WEB
	call ASCII_A
	call ZEILE2
	LDS temp1,(adr_TCP_PORT_WEB_A_L)
	LDS temp2,(adr_TCP_PORT_WEB_A_H)
	jmp ZAHL_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_PORT_WEB_B:
	call TASTE_PLUS_C
	brcs MENUE_EDIT_PORT_WEB_B_PLUS
	call TASTE_MINUS_C
	brcs MENUE_EDIT_PORT_WEB_B_MINUS
	jmp MENUE_EDIT_PORT_WEB_B_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_B_PLUS:
	LDS ZL,(adr_TCP_PORT_WEB_B_L)
	LDS ZH,(adr_TCP_PORT_WEB_B_H)
	adiw ZL,1
	STS(adr_TCP_PORT_WEB_B_L),ZL
	STS(adr_TCP_PORT_WEB_B_H),ZH
	jmp MENUE_EDIT_PORT_WEB_B_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_B_MINUS:
	LDS ZL,(adr_TCP_PORT_WEB_B_L)
	LDS ZH,(adr_TCP_PORT_WEB_B_H)
	sbiw ZL,1
	STS(adr_TCP_PORT_WEB_B_L),ZL
	STS(adr_TCP_PORT_WEB_B_H),ZH
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_B_w:
	call TEXT_EDIT
	call TEXT_PORT
	call TEXT_WEB
	call ASCII_B
	call ZEILE2
	LDS temp1,(adr_TCP_PORT_WEB_B_L)
	LDS temp2,(adr_TCP_PORT_WEB_B_H)
	jmp ZAHL_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_PORT_WEB_C:
	call TASTE_PLUS_C
	brcs MENUE_EDIT_PORT_WEB_C_PLUS
	call TASTE_MINUS_C
	brcs MENUE_EDIT_PORT_WEB_C_MINUS
	jmp MENUE_EDIT_PORT_WEB_C_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_C_PLUS:
	LDS ZL,(adr_TCP_PORT_WEB_C_L)
	LDS ZH,(adr_TCP_PORT_WEB_C_H)
	adiw ZL,1
	STS(adr_TCP_PORT_WEB_C_L),ZL
	STS(adr_TCP_PORT_WEB_C_H),ZH
	jmp MENUE_EDIT_PORT_WEB_C_w
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_C_MINUS:
	LDS ZL,(adr_TCP_PORT_WEB_C_L)
	LDS ZH,(adr_TCP_PORT_WEB_C_H)
	sbiw ZL,1
	STS(adr_TCP_PORT_WEB_C_L),ZL
	STS(adr_TCP_PORT_WEB_C_H),ZH
;-------------------------------------------------------------------------------
MENUE_EDIT_PORT_WEB_C_w:
	call TEXT_EDIT
	call TEXT_PORT
	call TEXT_WEB
	call ASCII_C
	call ZEILE2
	LDS temp1,(adr_TCP_PORT_WEB_C_L)
	LDS temp2,(adr_TCP_PORT_WEB_C_H)
	jmp ZAHL_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TX_ENC_REGISTER:
	call TEXT_TX
	call TEXT_ENC
	call TEXT_REGISTER
	call ZEILE2
	call TEXT_RS232
	call ZEILE3
	call TEXT_KLARTEXT
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_TX_ENC_REGISTER_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_TX_ENC_REGISTER_RUN:
	jmp DEBUG_TX_ALLE_ENC_REGISTER
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SAVE:
	call TEXT_SAVE
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_SAVE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SAVE_RUN:
	jmp EEPROM_SAVE
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WERKSEINSTELLUNG:
	call BEEP_KURZ
	call TEXT_WERKSEINSTELLUNG
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_WERKSEINSTELLUNG_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_WERKSEINSTELLUNG_RUN:
	STS(adr_VERSION),NULL
	call EEPROM_SAVE
	jmp PROGRAMM_RESET
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FIREWALL_CLEAR:
	call TEXT_FIREWALL
	call TEXT_CLEAR
	call TASTE_PLUS_C	; TASTE '+'				
	brcs MENUE_FIREWALL_CLEAR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_FIREWALL_CLEAR_RUN:
	call FW_CLEAR
	call BEEP_KURZ
	jmp  LCD_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
