; Client			Server	
; SYN 	----------->		
; 		<-----------SYN-ACK	
; ACK 	----------->		
; DATA 	----------->		
;							
; FIN 	----------->		
; 		<-----------ACK		
; 		<-----------FIN		
; ACK 	----------->		
; ##############################################################################
; ##############################################################################
; ##############################################################################
OFFENTLICHE_IP_AUSLESEN:
.equ IP_ERROR_A	=66
.equ IP_ERROR_B	=88


	call FUNCTION_IP_OFFENTLICH_NULL_CHECK_C	; IP=0.0.0.0 ---> C=1	
	brcc OFFENTLICHE_IP_AUSLESEN_EXIT
	call FUNCTION_IP_SERVER_EXTERN_NULL_CHECK_C ; IP=0.0.0.0 ---> C=1	
	brcc OFFENTLICHE_IP_AUSLESEN_RUN
;-------------------------------------------------------------------------------
OFFENTLICHE_IP_AUSLESEN_EXIT:
	ret
;-------------------------------------------------------------------------------
OFFENTLICHE_IP_AUSLESEN_RUN:
	call FUNCTION_IP_OFFENTLICH_NULL
	ldi temp2,high (80)				; Port 80 !	
	ldi temp1,low  (80)
	STS(adr_EXTERN_TCP_PORT_DEST_L),temp1
	STS(adr_EXTERN_TCP_PORT_DEST_H),temp2

	call ZUFALLSZAHL_TEMP1
	STS(adr_EXTERN_TCP_PORT_L),temp1
	call ZUFALLSZAHL_TEMP1
	STS(adr_EXTERN_TCP_PORT_H),temp1
;-------------------------------------------------------------------------------
	jmp TCP_CONNECT
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
OFFENTLICH_IP_RX:
	ldi temp,(ZEIT_PORT_CLOSE)
	STS(adr_TCP_PORT_OPEN),temp
;-------------------------------------------------------------------------------
	LDS temp,(TCPflags)
	cpi temp,(1<<TCPflag_SYN)|(1<<TCPflag_ACK)	; SYN-ACK	
	brne TCP_RX_IP0
	LED_ONLINE_ON
	call TCP_TX_ACK
	call WAIT_20ms
	call TCP_TX_GET_DATA
	ret
TCP_RX_IP0:
;-------------------------------------------------------------------------------
	cpi temp,(1<<TCPflag_PUSH)|(1<<TCPflag_ACK)	; PUSH ACK	
	brne TCP_RX_IP1
	LED_ONLINE_OFF
	rcall TCP_RX_IP_AUSWERTUNG
	ret
TCP_RX_IP1:
;-------------------------------------------------------------------------------
	cpi temp,(1<<TCPflag_FIN)|(1<<TCPflag_ACK)	; FIN-ACK	
	brne TCP_RX_IP2
	call TCP_TX_ACK
	call WAIT_20ms
	call MAKE_TCP_FLAG_FIN_ACK
	call TCP_TX_PAKET
	LED_ONLINE_OFF
	ret
TCP_RX_IP2:
;-------------------------------------------------------------------------------
ret
	call LCD_CLEAR
	LDS temp1,(TCPflags)
	call ANZEIGE_TCP_FLAGS_TEXT_TEMP1
	call WAIT_1s
	call WAIT_1s
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bsp: "Current IP Address: 91.50.184.20"										
TCP_RX_IP_AUSWERTUNG:
;-------------------------------------------------------------------------------
; nach "Address:" suchen														
	ldi XL,low (TCPdata)			; TCPdata	
	ldi XH,high(TCPdata)
	ldi temp9,255					; Schleife	
TCP_RX_IP_s1:
	ldi ZL,  low(IP_SEARCH_STRING*2); TABELLE	
	ldi ZH, high(IP_SEARCH_STRING*2)
TCP_RX_IP_s2:
	dec temp9						; Schleife	
	brne TCP_RX_IP_s3
;-------------------------------------------------------------------------------
	ldi temp,(ERROR_IP)
	call WARNUNG_SAVE_TEMP
	ldi temp,(IP_ERROR_A)			; ERROR		
	STS(adr_IP_OFFENTLICH0),temp
	STS(adr_IP_OFFENTLICH1),temp
	STS(adr_IP_OFFENTLICH2),temp
	STS(adr_IP_OFFENTLICH3),temp
	ret
;-------------------------------------------------------------------------------
TCP_RX_IP_s3:
	LPM temp1,Z+				; TABELLE	
	cpi temp1,255				; ENDE ?	
	breq TCP_RX_IP_TREFFER
	LD temp,X+					; TCPdata	
	cp temp,temp1
	breq TCP_RX_IP_s2
	brne TCP_RX_IP_s1
;-------------------------------------------------------------------------------
TCP_RX_IP_TREFFER:
	call TCP_RX_IP_NEXT_ZAHL_TEMP1
	STS(adr_IP_OFFENTLICH0),temp1
	call TCP_RX_IP_NEXT_ZAHL_TEMP1
	STS(adr_IP_OFFENTLICH1),temp1
	call TCP_RX_IP_NEXT_ZAHL_TEMP1
	STS(adr_IP_OFFENTLICH2),temp1
	call TCP_RX_IP_NEXT_ZAHL_TEMP1
	STS(adr_IP_OFFENTLICH3),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "91.50.84.20"																	
TCP_RX_IP_NEXT_ZAHL_TEMP1:
	clr temp1	;   1-er	
	clr temp2	;  10-er	
	clr temp3	; 100-er	
	ldi temp9,255
;-------------------------------------------------------------------------------
TCP_RX_IP_NEXT_s:
	dec temp9
	brne TCP_RX_IP_NEXT_w
;-------------------------------------------------------------------------------
	ldi temp1,(IP_ERROR_B)					; Error, keine ASCII-Zahl gefunden	
	ldi temp,(ERROR_IP)
	call WARNUNG_SAVE_TEMP
	ret
;-------------------------------------------------------------------------------
TCP_RX_IP_NEXT_w:
	LD temp,X+						; TCPdata		
	call FUNCTION_0123456789_TEMP_C
	brcc TCP_RX_IP_NEXT_s			; ASCII-Zahl ?	
	mov temp3,temp	; 100-er	

	LD temp,X+						; TCPdata		
	call FUNCTION_0123456789_TEMP_C
	brcc TCP_RX_IP_NEXT_schieben	; ASCII-Zahl ?	
	mov temp2,temp	; 100-er	

	LD temp,X+						; TCPdata		
	call FUNCTION_0123456789_TEMP_C
	brcc TCP_RX_IP_NEXT_schieben	; ASCII-Zahl ?	
	mov temp1,temp	; 100-er	
;-------------------------------------------------------------------------------
TCP_RX_IP_NEXT_schieben:
	tst temp1		; 1-er NULL?
	brne TCP_RX_IP_NEXT_AUSWERTUNG
	mov temp1,temp2
	mov temp2,temp3
	clr temp3		; NULL		
	tst temp1		; 1-er NULL?
	brne TCP_RX_IP_NEXT_AUSWERTUNG
	mov temp1,temp2
	clr temp2		; NULL		
;-------------------------------------------------------------------------------
TCP_RX_IP_NEXT_AUSWERTUNG:
	tst temp3		; 100-er		
	breq TCP_RX_IP_NEXT_w1
	subi temp3,48	; ASCII->BIN	
TCP_RX_IP_NEXT_w1:
	tst temp2		;  10-er		
	breq TCP_RX_IP_NEXT_w2
	subi temp2,48	; ASCII->BIN	
TCP_RX_IP_NEXT_w2:
	tst temp1		;   1-er		
	breq TCP_RX_IP_NEXT_w3
	subi temp1,48	; ASCII->BIN	
TCP_RX_IP_NEXT_w3:
;-------------------------------------------------------------------------------
	ldi temp,100	; 100-er		
	MUL temp3,temp
	mov temp6,R0	; Ergenis		
	ldi temp,10		;  10-er		
	MUL temp2,temp
	add temp6,R0	; Ergenis		
	add temp6,temp1	;   1-er		
	mov temp1,temp6	; Ergenis		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Ziffer gefunden, dann Carry=1													
FUNCTION_0123456789_TEMP_C:
	cpi temp,'0'	
	breq FUNCTION_0123456789_YES
	cpi temp,'1'	
	breq FUNCTION_0123456789_YES
	cpi temp,'2'	
	breq FUNCTION_0123456789_YES
	cpi temp,'3'	
	breq FUNCTION_0123456789_YES
	cpi temp,'4'	
	breq FUNCTION_0123456789_YES
	cpi temp,'5'	
	breq FUNCTION_0123456789_YES
	cpi temp,'6'	
	breq FUNCTION_0123456789_YES
	cpi temp,'7'	
	breq FUNCTION_0123456789_YES
	cpi temp,'8'	
	breq FUNCTION_0123456789_YES
	cpi temp,'9'	
	breq FUNCTION_0123456789_YES
	CLC 			;Clear Carry
	ret
FUNCTION_0123456789_YES:
	SEC 			;Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
TCP_TX_GET_DATA:
	call WAIT_50ms
	ldi ZH, high(IP_GET*2)	; TABELLE
	ldi ZL,  low(IP_GET*2)
;-------------------------------------------------------------------------------
; TCP-DATEN																		
;-------------------------------------------------------------------------------
	ldi XL,low (TCPdata)	; X-initalisieren
	ldi XH,high(TCPdata)
;-------------------------------------------------------------------------------
; aus Tabelle bernehmen														
;-------------------------------------------------------------------------------
TCP_TX_IP_DATA_s:
	LPM temp,Z+
	cpi temp,255
	breq TCP_TX_IP_DATA_w
	ST X+,temp
	rjmp TCP_TX_IP_DATA_s
TCP_TX_IP_DATA_w:
;-------------------------------------------------------------------------------
	mov temp1,XL
	mov temp2,XH
	ldi temp3,low (IP4_HEADER)
	ldi temp4,high(IP4_HEADER)
	sub temp1,temp3
	sbc temp2,temp4
	STS(IP4TotalLengthL),temp1
	STS(IP4TotalLengthH),temp2
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	call MAKE_TCP_FLAG_PUSH_ACK				; TCP-FLAG-PUSH-ACK				
	call TCP_TX_PAKET
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################






