; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_INITIALISIERUNG:
	; auf EINGANG		
	cbi (TASTE_MENUE_PLUS_DDR), (TASTE_MENUE_PLUS_PIN_NR)
	cbi (TASTE_MENUE_MINUS_DDR), (TASTE_MENUE_MINUS_PIN_NR)
	cbi (TASTE_PLUS_DDR),(TASTE_PLUS_PIN_NR)
	cbi (TASTE_MINUS_DDR),(TASTE_MINUS_PIN_NR)
	; PULL-UP ein		
	sbi (TASTE_MENUE_PLUS_PORT),(TASTE_MENUE_PLUS_PIN_NR)
	sbi (TASTE_MENUE_MINUS_PORT),(TASTE_MENUE_MINUS_PIN_NR)
	sbi (TASTE_PLUS_PORT),(TASTE_PLUS_PIN_NR)
	sbi (TASTE_MINUS_PORT),(TASTE_MINUS_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	WDR
	ldi temp,(MODUL_TASTEN)									; MODUL		
	STS(adr_MODUL_NR),temp
	clr temp
	ldi temp9,255
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_s:
	; Taste "MENUE-PLUS"gedrckt ?	
	sbis (TASTE_MENUE_PLUS_PIN),(TASTE_MENUE_PLUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,1
	; Taste "MENUE-MINUS"gedrckt ?	
	sbis (TASTE_MENUE_MINUS_PIN),(TASTE_MENUE_MINUS_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,2
	; Taste "PLUS"gedrckt ?		
	sbis (TASTE_PLUS_PIN),(TASTE_PLUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,4
	; Taste "MINUS"gedrckt ?		
	sbis (TASTE_MINUS_PIN),(TASTE_MINUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,8
	; speichern						
	STS(adr_TASTE),temp
	tst temp
	brne TASTEN_ABFRAGE_W
	; Schleife						
	dec temp9
	brne TASTEN_ABFRAGE_s
	ret
;-------------------------------------------------------------------------------
; Neustart / SOFT-RESET ?														
TASTEN_ABFRAGE_W:
	cpi temp,(4+8)
	brne TASTEN_ABFRAGE_FERTIG
	jmp PROGRAMM_RESET	
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_FERTIG:
	call BEEP_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)	
	tst temp
	brne TASTEN_WAIT_RUN
	call WAIT_20ms
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
	jmp WAIT_200ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MENUE +																		
TASTE_MENUE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,1
	rjmp TASTE_ANTWORT
; ##############################################################################
; MENUE -																		
TASTE_MENUE_MINUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,2
	rjmp TASTE_ANTWORT
; ##############################################################################
; TASTE +																		
TASTE_PLUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,4
	rjmp TASTE_ANTWORT
; ##############################################################################
; TASTE -																		
TASTE_MINUS_C:
	LDS temp,(adr_TASTE)
	cpi temp,8
	rjmp TASTE_ANTWORT
; ##############################################################################
TASTE_ANTWORT:
	breq TASTE_ANTWORT_SET
	CLC 	;Clear Carry
	ret
TASTE_ANTWORT_SET:
	SEC ;Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTE_PLUS_MINUS_TEMP1:
	call TASTE_PLUS_C
	brcc TASTE_PLUS_MINUS_TEMP1_w
	inc temp1
	ret
;-------------------------------------------------------------------------------
TASTE_PLUS_MINUS_TEMP1_w:
	call TASTE_MINUS_C
	brcc TASTE_PLUS_MINUS_TEMP1_FERTIG
	dec temp1
TASTE_PLUS_MINUS_TEMP1_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
